# ARST打卡第251周

<!--more-->

lc235_二叉搜索树的最近公共祖先 TED演讲：努力工作真的能让你成为一个好人吗？ leveldb之MANIFEST 遍历相应结构的目录批量修复leveldb目录损坏

## Algorithm
lc235_二叉搜索树的最近公共祖先

思路: 
通过先递归判断哪个根有p,q两个节点，每找到一个，return的val就加1.

不过要注意传递指针参数的时候要用`**`。

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */

class Solution {
public:
    int find(TreeNode* root, TreeNode* p, TreeNode* q, TreeNode** ans) {
        int ret = 0;
        // 放这里不对，是子递归先获取ans, 所以应该放在子递归后面
        // if (ans) {
        //     return 3;
        // }
        if (!root) {
            return ret;
        }
        if (root->val == p->val || root->val == q->val) {
            ret ++;
        }
        ret += find(root->left, p, q, ans) + 
               find(root->right, p, q, ans);
        if (*ans == nullptr && ret == 2) {
            *ans = root;
        }
        return ret;
    }

    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        // 通过先递归判断哪个根有p,q两个节点，每找到一个，return的val就加1.
        TreeNode* ans = nullptr;
        // NOTICE: 别传了一个形参。
        find(root, p, q, &ans);
        return ans;
    }
};
```

自己的答案没有得出来，然后看[题解](https://leetcode.cn/problems/lowest-common-ancestor-of-a-binary-search-tree/solutions/428633/er-cha-sou-suo-shu-de-zui-jin-gong-gong-zu-xian-26/)发现这竟然是个二叉搜索树...自己当成了一般树在做...

二叉搜索树就很简单了，就是可以判断不在同一边就是答案。

```cpp
class Solution {
public:
    TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
        TreeNode* ancestor = root;
        while (true) {
            if (p->val < ancestor->val && q->val < ancestor->val) {
                ancestor = ancestor->left;
            }
            else if (p->val > ancestor->val && q->val > ancestor->val) {
                ancestor = ancestor->right;
            }
            else {
                break;
            }
        }
        return ancestor;
    }
};
```

## Review
TED演讲：努力工作真的能让你成为一个好人吗？


<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=1900437726&bvid=BV1wm411X7y6&cid=1433992277&p=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>

大家都有一个由来以及的偏见认知: 就是越努力工作的人道德标准越高。

然后导致内卷无意义的工作，把休息和陪伴家人的时间都消耗了。

努力做有意义的工作，而不是做努力做无意义的工作。并且把努力和道德分离开来。

## Tips
[leveldb之MANIFEST](https://bean-li.github.io/leveldb-manifest/)

## Share
遍历相应结构的目录批量修复leveldb目录损坏

cpp小工具，编译make记得链接 leveldb 和 snappy.

```cpp
#include <iostream>
#include <vector>
#include <string>
#include <dirent.h>
#include <sys/stat.h>
#include "leveldb/db.h"
#include <unistd.h>
using namespace std;

// 递归遍历目录函数
void traverseDirectory(const std::string& directory, const std::string& targetDir, std::vector<std::string>& foundDirs) {
    DIR* dir = opendir(directory.c_str());
    if (dir == nullptr) {
        std::cerr << "Failed to open directory: " << directory << std::endl;
        return;
    }

    struct dirent* entry;
    while ((entry = readdir(dir)) != nullptr) {
        std::string name = entry->d_name;
        if (name != "." && name != "..") {
            std::string path = directory + "/" + name;
            struct stat fileStat;
            if (stat(path.c_str(), &fileStat) == 0 && S_ISDIR(fileStat.st_mode)) {
                if (name == targetDir) {
                    foundDirs.push_back(path);
                } else {
                    traverseDirectory(path, targetDir, foundDirs);
                }
            }
        }
    }

    closedir(dir);
}

int main() {
    std::vector<std::string> foundDirs;

    std::string targetDir = "dbengine";
    std::string rootPath = "ts";

    traverseDirectory(rootPath, targetDir, foundDirs);

    if (foundDirs.empty()) {
        std::cout << "No '" << targetDir << "' directories found.\n";
    } else {
        leveldb::Options options;
        std::cout << "Found " << foundDirs.size() << " '" << targetDir << "' directories:\n";
        for (const auto& dir : foundDirs) {
            cout << "Repairing the database in " << dir  << endl;
            leveldb::Status status = leveldb::RepairDB(cwd, options);

            if (!status.ok()) {
                cerr << "Repairing the database failed." << endl;
                return 1;
            }
        }
        cerr << "Repairing the database was sucessful." << endl;
    }

    return 0;
}
```
